cookutils view cook @ rev 268

cook: download retry
author Pascal Bellard <pascal.bellard@slitaz.org>
date Thu Oct 13 13:37:49 2011 +0200 (2011-10-13)
parents f2a39a4e6bb8
children a3dfd81ec91f
line source
1 #!/bin/sh
2 #
3 # Cook - A tool to cook and generate SliTaz packages. Read the README
4 # before adding or modifing any code in cook!
5 #
6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
7 # Author: Christophe Lincoln <pankso@slitaz.org>
8 #
10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
11 [ -f "cook.conf" ] && . ./cook.conf
13 # Share DB and status with the Cooker.
14 activity="$CACHE/activity"
15 command="$CACHE/command"
16 broken="$CACHE/broken"
17 blocked="$CACHE/blocked"
19 # Old style compatibility
20 SOURCES_REPOSITORY=$SRC
22 #
23 # Functions
24 #
26 usage() {
27 cat << EOT
29 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
31 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
32 usage|help $(gettext "Display this short usage.")
33 setup $(gettext "Setup your build environment.")
34 test $(gettext "Test environment and cook a package.")
35 list-wok $(gettext "List packages in the wok.")
36 search $(gettext "Simple packages search function.")
37 new $(gettext "Create a new package with a receipt".)
38 list $(gettext "Cook a list of packages.")
39 clean-wok $(gettext "Clean-up all packages files.")
40 clean-src $(gettext "Clean-up all packages sources.")
41 pkgdb $(gettext "Create packages DB lists and flavors.")
43 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
44 --clean|-c Cook : $(gettext "clean the package in the wok.")
45 --install|-i Cook : $(gettext "cook and install the package.")
46 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
47 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
48 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
49 --interactive|-x New : $(gettext "create a receipt interactively.")
50 --wok|-w Setup: $(gettext "clone the cooking wok from Hg repo.")
51 --stable Setup: $(gettext "clone the stable wok from Hg repo.")
52 --undigest Setup: $(gettext "clone the undigest wok from Hg repo.")
53 --flavors Pkgdb: $(gettext "create up-to-date flavors files.")
55 EOT
56 exit 0
57 }
59 # Be sure we're root.
60 check_root() {
61 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
62 }
64 separator() {
65 echo "================================================================================"
66 }
68 status() {
69 echo -en "\\033[70G[ "
70 if [ $? = 0 ]; then
71 echo -en "\\033[1;32mOK"
72 else
73 echo -en "\\033[1;31mFailed"
74 fi
75 echo -e "\\033[0;39m ]"
76 }
78 # Log activities, we want first letter capitalized.
79 log() {
80 grep ^[A-Z] | \
81 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
82 }
84 # We don't want these escapes in web interface.
85 clean_log() {
86 sed -i -e s'|\[70G\[ \[1;32m| |' \
87 -e s'|\[0;39m \]||' $LOGS/$pkg.log
88 }
90 # Log broken packages.
91 broken() {
92 if ! grep -q "^$pkg$" $broken; then
93 echo "$pkg" >> $broken
94 fi
95 }
97 # Be sure package exists in wok.
98 check_pkg_in_wok() {
99 if [ ! -d "$WOK/$pkg" ]; then
100 gettext -e "\nUnable to find package in the wok:"
101 echo -e " $pkg\n" && exit 1
102 fi
103 }
105 if_empty_value() {
106 if [ -z "$value" ]; then
107 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
108 exit 1
109 fi
110 }
112 # Initialize files used in $CACHE
113 init_db_files() {
114 gettext "Creating directories structure in:"; echo " $SLITAZ"
115 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
116 gettext "Creating DB files in:"; echo " $CACHE"
117 for f in $activity $command $broken $blocked
118 do
119 touch $f
120 done
121 }
123 # QA: check a receipt consistency before building.
124 receipt_quality() {
125 gettext -e "QA: checking package receipt...\n"
126 unset online
127 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
128 online="online"
129 fi
130 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
131 do
132 unset value
133 value=$(grep ^$var= $receipt | cut -d \" -f 2)
134 case "$var" in
135 PACKAGE|VERSION|SHORT_DESC)
136 if_empty_value ;;
137 CATEGORY)
138 [ -z "$value" ] && value="empty"
139 valid="base-system x-window utilities network graphics \
140 multimedia office development system-tools security games \
141 misc meta non-free"
142 if ! echo "$valid" | grep -q -w "$value"; then
143 gettext "QA: unknown category:"; echo -e " $value\n"
144 exit 1
145 fi ;;
146 WEB_SITE)
147 # We don't check WGET_URL since if dl is needed it will fail.
148 # Break also if we're not online. Here error is not fatal.
149 if_empty_value
150 [ -z "$online" ] || break
151 if ! busybox wget -T 12 -s $value 2>/dev/null; then
152 gettext "QA: Unable to reach:"; echo -e " $value"
153 fi ;;
154 esac
155 done
156 }
158 # Executed before sourcing a receipt.
159 unset_receipt() {
160 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
161 }
163 # Paths used in receipt and by cook itself.
164 set_paths() {
165 pkgdir=$WOK/$PACKAGE
166 src=$pkgdir/source/$PACKAGE-$VERSION
167 taz=$pkgdir/taz
168 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
169 fs=$pack/fs
170 stuff=$pkgdir/stuff
171 install=$pkgdir/install
172 if [ "$WANTED" ]; then
173 src=$WOK/$WANTED/source/$WANTED-$VERSION
174 install=$WOK/$WANTED/install
175 wanted_stuff=$WOK/$WANTED/stuff
176 fi
177 # Kernel version is set from linux-api-headers since it is part of toolchain.
178 if [ -f "$INSTALLED/linux-api-headers/receipt" ]; then
179 kvers=$(grep ^VERSION= $INSTALLED/linux-api-headers/receipt | cut -d '"' -f 2)
180 fi
181 # Old way compatibility.
182 _pkg=$install
183 }
185 # Create source tarball when URL is a SCM.
186 create_tarball() {
187 gettext "Creating tarball: "; echo "$tarball"
188 if [ "$LZMA_SRC" ]; then
189 tar -c $pkgsrc | lzma e $SRC/$tarball -si || exit 1
190 else
191 tar cjf $tarball $pkgsrc || exit 1
192 mv $tarball $SRC && rm -rf $pkgsrc
193 fi
194 }
196 # Get package source. For SCM we are in cache so clone here and create a
197 # tarball here.
198 get_source() {
199 pwd=$(pwd)
200 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
201 tarball=$pkgsrc.tar.bz2
202 [ "$LZMA_SRC" ] && tarball=$pkgsrc.tar.lzma
203 case "$WGET_URL" in
204 http://*|ftp://*)
205 # Busybox Wget is better!
206 busybox wget -T 60 -c -O $SRC/$TARBALL $WGET_URL || \
207 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
208 https://*)
209 wget -c --no-check-certificate -O $SRC/$TARBALL $WGET_URL || \
210 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
211 hg*|mercurial*)
212 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
213 url=${WGET_URL#hg|}
214 else
215 url=${WGET_URL#mercurial|}
216 fi
217 gettext -e "Getting source from Hg...\n"
218 echo "URL: $url"
219 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
220 if [ "$BRANCH" ]; then
221 echo "Hg branch: $BRANCH"
222 hg clone $url --rev $BRANCH $pkgsrc || \
223 (echo "ERROR: hg clone $url --rev $BRANCH" && exit 1)
224 else
225 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
226 fi
227 rm -rf $pkgsrc/.hg
228 create_tarball ;;
229 git*)
230 url=${WGET_URL#git|}
231 gettext -e "Getting source from Git...\n"
232 echo "URL: $url"
233 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
234 if [ "$BRANCH" ]; then
235 echo "Git branch: $BRANCH"
236 cd $pkgsrc && git checkout $BRANCH && cd ..
237 fi
238 create_tarball ;;
239 cvs*)
240 url=${WGET_URL#cvs|}
241 mod=$PACKAGE
242 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
243 gettext -e "Getting source from CVS...\n"
244 echo "URL: $url"
245 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
246 gettext "Cloning to: "; echo "$pwd/$mod"
247 cvs -d:$url co $mod && mv $mod $pkgsrc
248 create_tarball ;;
249 svn*|subversion*)
250 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
251 url=${WGET_URL#svn|}
252 else
253 url=${WGET_URL#subversion|}
254 fi
255 gettext -e "Getting source from SVN...\n"
256 echo "URL: $url"
257 if [ "$BRANCH" ]; then
258 echo t | svn co $url -r $BRANCH $pkgsrc
259 else
260 echo t | svn co $url $pkgsrc
261 fi
262 create_tarball ;;
263 *)
264 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
265 tee -a $LOGS/$PACKAGE.log
266 exit 1 ;;
267 esac
268 }
270 # Extract source package.
271 extract_source() {
272 if [ ! -s "$SRC/$TARBALL" ]; then
273 local url
274 url="http://mirror.slitaz.org/sources/packages"
275 url=$url/${TARBALL:0:1}/$TARBALL
276 gettext "Getting source from mirror:"; echo " $url"
277 busybox wget -c -P $SRC $url || echo -e "ERROR: wget $url"
278 fi
279 gettext "Extracting:"; echo " $TARBALL"
280 case "$TARBALL" in
281 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
282 *.tar.bz2|*.tbz|*.tbz2) tar xjf $SRC/$TARBALL 2>/dev/null ;;
283 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
284 *.tar) tar xf $SRC/$TARBALL ;;
285 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
286 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
287 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
288 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
289 *.run) /bin/sh $SRC/$TARBALL $RUN_OPTS ;;
290 *) cp $SRC/$TARBALL $(pwd) ;;
291 esac
292 }
294 # Display cooked package summary.
295 summary() {
296 cd $WOK/$pkg
297 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
298 fs=$(du -sh taz/* | awk '{print $1}')
299 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
300 files=$(cat taz/$pkg-*/files.list | wc -l)
301 cookdate=$(date "+%Y-%m-%d %H:%M")
302 sec=$time
303 div=$(($time / 60))
304 [ "$div" != 0 ] && min="~ ${div}m"
305 gettext "Summary for:"; echo " $PACKAGE $VERSION"
306 separator
307 [ "$prod" ] && echo "Produced : $prod"
308 cat << EOT
309 Packed : $fs
310 Compressed : $size
311 Files : $files
312 Cook time : ${sec}s $min
313 Cook date : $cookdate
314 $(separator)
315 EOT
316 }
318 # Display debugging error info.
319 debug_info() {
320 echo -e "\nDebug information"
321 separator
322 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
323 for error in \
324 ERROR "No package" "cp: can't" "can't open" "can't cd" \
325 "error:" "fatal error:"
326 do
327 fgrep "$error" $LOGS/$pkg.log
328 done
329 separator && echo ""
330 }
332 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
333 # so some packages need to copy these files with the receipt and genpkg_rules.
334 copy_generic_files()
335 {
336 # $LOCALE is set in cook.conf
337 if [ "$LOCALE" ]; then
338 if [ -d "$install/usr/share/locale" ]; then
339 mkdir -p $fs/usr/share/locale
340 for i in $LOCALE
341 do
342 if [ -d "$install/usr/share/locale/$i" ]; then
343 cp -a $install/usr/share/locale/$i $fs/usr/share/locale
344 fi
345 done
346 fi
347 fi
349 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
350 if [ "$GENERIC_PIXMAPS" != "no" ]; then
351 if [ -d "$install/usr/share/pixmaps" ]; then
352 mkdir -p $fs/usr/share/pixmaps
353 cp -a $install/usr/share/pixmaps/$PACKAGE.png \
354 $fs/usr/share/pixmaps 2>/dev/null || return 0
355 cp -a $install/usr/share/pixmaps/$PACKAGE.xpm \
356 $fs/usr/share/pixmaps 2>/dev/null || return 0
357 fi
359 # Custom or homemade PNG pixmap can be in stuff.
360 if [ -f "$stuff/$PACKAGE.png" ]; then
361 mkdir -p $fs/usr/share/pixmaps
362 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
363 fi
364 fi
366 # Desktop entry (.desktop).
367 if [ -d "$install/usr/share/applications" ] && [ "$WANTED" == "" ]; then
368 cp -a $install/usr/share/applications $fs/usr/share
369 fi
371 # Homemade desktop file(s) can be in stuff.
372 if [ -d "$stuff/applications" ]; then
373 mkdir -p $fs/usr/share
374 cp -a $stuff/applications $fs/usr/share
375 fi
376 if [ -f "$stuff/$PACKAGE.desktop" ]; then
377 mkdir -p $fs/usr/share/applications
378 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
379 fi
380 }
382 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
383 # as removing uneeded files like in Python packages.
384 strip_package()
385 {
386 gettext "Executing strip on all files..."
387 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
388 do
389 if [ -d "$dir" ]; then
390 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
391 fi
392 done
393 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
394 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
395 status
397 # Remove Python .pyc and .pyo from packages.
398 if echo "$PACKAGE $DEPENDS" | fgrep -q "python"; then
399 gettext "Removing Python compiled files..."
400 find $fs -type f -name "*.pyc" -delete 2>/dev/null
401 find $fs -type f -name "*.pyo" -delete 2>/dev/null
402 status
403 fi
405 # Remove Perl perllocal.pod and .packlist from packages.
406 if echo "$DEPENDS" | fgrep -q "perl"; then
407 gettext "Removing Perl compiled files..."
408 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
409 find $fs -type f -name ".packlist" -delete 2>/dev/null
410 status
411 fi
412 }
414 # Remove installed deps.
415 remove_deps() {
416 # Now remove installed build deps.
417 diff="$CACHE/installed.cook.diff"
418 if [ -s "$CACHE/installed.cook.diff" ]; then
419 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
420 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
421 gettext "Build dependencies to remove:"; echo " $nb"
422 gettext "Removing:"
423 for dep in $deps
424 do
425 echo -n " $dep"
426 echo 'y' | tazpkg remove $dep >/dev/null
427 done
428 echo -e "\n"
429 # Keep the last diff for debug and info.
430 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
431 fi
432 }
434 # The main cook function.
435 cookit() {
436 echo "Cook: $PACKAGE $VERSION"
437 separator
438 set_paths
439 [ "$QA" ] && receipt_quality
440 cd $pkgdir
441 rm -rf install taz source
443 # Disable -pipe if less than 512Mb free RAM.
444 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
445 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
446 gettext -e "Disabling -pipe compile flag: $free RAM\n"
447 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
448 CXXFLAGS="${CXXFLAGS/-pipe}" && \
449 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
450 fi
451 unset free
453 # Export flags and path to be used by make and receipt.
454 DESTDIR=$pkgdir/install
455 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS CONFIG_SITE LC_ALL=C LANG=C
457 # Check for build deps and handle implicit depends of *-dev packages
458 # (ex: libusb-dev :: libusb).
459 rm -f $CACHE/installed.local $CACHE/installed.web $CACHE/missing.dep
460 touch $CACHE/installed.local $CACHE/installed.web
461 [ "$BUILD_DEPENDS" ] && gettext -e "Checking build dependencies...\n"
462 for dep in $BUILD_DEPENDS
463 do
464 implicit=${dep%-dev}
465 for i in $dep $implicit
466 do
467 if [ ! -f "$INSTALLED/$i/receipt" ]; then
468 # Try local package first. In some cases implicit doesn't exist, ex:
469 # libboost-dev exists but not libboost, so check if we got vers.
470 unset vers
471 vers=$(grep ^VERSION= $WOK/$i/receipt 2>/dev/null | cut -d '"' -f 2)
472 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
473 echo $i-$vers.tazpkg >> $CACHE/installed.local
474 else
475 # Priority to package version in wok (maybe more up-to-date)
476 # than the mirrored one.
477 if [ "$vers" ]; then
478 if fgrep -q $i-$vers $DB/packages.list; then
479 echo $i >> $CACHE/installed.web
480 else
481 # So package exists in wok but not available.
482 gettext "Missing dep (wok/pkg):"; echo " $i $vers"
483 echo $i >> $CACHE/missing.dep
484 fi
485 else
486 # Package is not in wok but may be in repo.
487 if fgrep -q $i-$vers $DB/packages.list; then
488 echo $i >> $CACHE/installed.web
489 else
490 echo "ERROR: unknown dep $i" && exit 1
491 fi
492 fi
493 fi
494 fi
495 done
496 done
498 # Get the list of installed packages
499 cd $INSTALLED && ls -1 > $CACHE/installed.list
501 # Have we a missing build dep to cook ?
502 if [ -s "$CACHE/missing.dep" ] && [ "$AUTO_COOK" ]; then
503 gettext -e "Auto cook config is set : AUTO_COOK\n"
504 cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
505 for i in $(uniq $CACHE/missing.dep)
506 do
507 (gettext "Building dep (wok/pkg) :"; echo " $i $vers") | \
508 tee -a $LOGS/$PACKAGE.log.$$
509 cook $i || (echo -e "ERROR: can't cook dep '$i'\n" && \
510 fgrep "remove: " $LOGS/$i.log && \
511 fgrep "Removing: " $LOGS/$i.log && echo "") | \
512 tee -a $LOGS/$PACKAGE.log.$$ && break
513 done
514 rm -f $CACHE/missing.dep
515 mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
516 fi
518 # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
519 # is enabled and cook fails we have ERROR in log, if no auto cook we have
520 # missing dep in cached file.
521 if fgrep -q "ERROR:" $LOGS/$pkg.log || [ -s "$CACHE/missing.dep" ]; then
522 [ -s "$CACHE/missing.dep" ] && nb=$(cat $CACHE/missing.dep | wc -l)
523 echo "ERROR: missing dep $nb" && exit 1
524 fi
526 # Install local packages.
527 cd $PKGS
528 for i in $(uniq $CACHE/installed.local)
529 do
530 gettext "Installing dep (pkg/local):"; echo " $i"
531 tazpkg install $i >/dev/null
532 done
534 # Install web or cached packages (if mirror is set to $PKGS we only
535 # use local packages).
536 for i in $(uniq $CACHE/installed.web)
537 do
538 gettext "Installing dep (web/cache):"; echo " $i"
539 tazpkg get-install $i >/dev/null
540 done
542 # If a cook failed deps are removed.
543 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
544 [ ! -s "installed.cook.diff" ] && \
545 busybox diff installed.list installed.cook > installed.cook.diff
546 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
548 # Get source tarball and make sure we have source dir named:
549 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
550 # tarball if it exists.
551 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
552 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
553 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
554 LZMA_SRC=""
555 else
556 get_source || exit 1
557 fi
558 fi
559 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
560 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
561 if ! extract_source ; then
562 get_source
563 extract_source || exit 1
564 fi
565 if [ "$LZMA_SRC" ]; then
566 cd $pkgdir/source
567 if [ "$(ls -A tmp | wc -l)" -gl 1 ] || [ -f "$(echo tmp/*)" ]; then
568 mv tmp tmp-1 && mkdir tmp
569 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
570 fi
571 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
572 cd tmp && tar -c * | lzma e $SRC/$TARBALL -si
573 fi
574 fi
575 cd $pkgdir/source/tmp
576 # Some archives are not well done and don't extract to one dir (ex lzma).
577 files=$(ls | wc -l)
578 [ "$files" == 1 ] && [ -d "$(ls)" ] && mv * ../$PACKAGE-$VERSION
579 [ "$files" == 1 ] && [ -f "$(ls)" ] && mkdir -p ../$PACKAGE-$VERSION && \
580 mv * ../$PACKAGE-$VERSION/$TARBALL
581 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
582 mv * ../$PACKAGE-$VERSION
583 cd .. && rm -rf tmp
584 fi
586 # Execute receipt rules.
587 if grep -q ^compile_rules $receipt; then
588 gettext -e "Executing: compile_rules\n"
589 [ -d "$src" ] && cd $src
590 compile_rules $@ || exit 1
591 # Stay compatible with _pkg
592 [ -d "$src/_pkg" ] && mv $src/_pkg $install
593 # QA: compile_rules success so valid.
594 mkdir -p $install
595 else
596 # QA: No compile_rules so no error, valid.
597 mkdir -p $install
598 fi
599 separator && echo ""
600 }
602 # Cook quality assurance.
603 cookit_quality() {
604 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
605 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
606 fi
607 # ERROR can be echoed any time in cookit()
608 if fgrep -q ERROR: $LOGS/$pkg.log; then
609 debug_info | tee -a $LOGS/$pkg.log
610 rm -f $command && exit 1
611 fi
612 }
614 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
615 # but it doesn't handle EXTRAVERSION.
616 packit() {
617 set_paths
618 echo "Pack: $PACKAGE $VERSION"
619 separator
620 if grep -q ^genpkg_rules $receipt; then
621 gettext -e "Executing: genpkg_rules\n"
622 set -e && cd $pkgdir && mkdir -p $fs
623 genpkg_rules || echo -e "\nERROR: genpkg_rules failed\n" >> \
624 $LOGS/$pkg.log
625 else
626 gettext "No packages rules: meta package"; echo
627 mkdir -p $fs
628 fi
630 # First QA check to stop now if genpkg_rules failed.
631 if fgrep -q ERROR: $LOGS/$pkg.log; then
632 exit 1
633 fi
635 cd $taz
636 for file in receipt description.txt
637 do
638 [ ! -f "../$file" ] && continue
639 gettext "Copying"; echo -n " $file..."
640 cp -f ../$file $pack && chown 0.0 $pack/$file && status
641 done
642 copy_generic_files
644 # Create files.list with redirecting find output.
645 gettext "Creating the list of files..." && cd $fs
646 find . -type f -print > ../files.list
647 find . -type l -print >> ../files.list
648 cd .. && sed -i s/'^.'/''/ files.list
649 status
651 # Strip and stuff files.
652 strip_package
654 # Md5sum of files.
655 gettext "Creating md5sum of files..."
656 while read file; do
657 [ -L "fs$file" ] && continue
658 [ -f "fs$file" ] || continue
659 case "$file" in
660 /lib/modules/*/modules.*|*.pyc) continue ;;
661 esac
662 md5sum "fs$file" | sed 's/ fs/ /'
663 done < files.list > md5sum
664 status
665 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
666 description.txt 2> /dev/null | awk \
667 '{ sz=$1 } END { print sz }')
669 # Build cpio archives.
670 gettext "Compressing the fs... "
671 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
672 rm -rf fs
673 status
674 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
675 md5sum description.txt 2> /dev/null | awk \
676 '{ sz=$1 } END { print sz }')
677 gettext "Updating receipt sizes..."
678 sed -i s/^PACKED_SIZE.*$// receipt
679 sed -i s/^UNPACKED_SIZE.*$// receipt
680 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
681 status
683 # Set extra version.
684 if [ "$EXTRAVERSION" ]; then
685 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
686 sed -i s/^EXTRAVERSION.*$// receipt
687 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
688 status
689 fi
691 # Compress.
692 gettext "Creating full cpio archive... "
693 find . -print | cpio -o -H newc --quiet > \
694 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
695 status
696 gettext "Restoring original package tree... "
697 unlzma -c fs.cpio.lzma | cpio -idm --quiet
698 status
699 rm fs.cpio.lzma && cd ..
701 # QA and give info.
702 tazpkg=$(ls *.tazpkg)
703 packit_quality
704 separator && gettext "Package:"; echo -e " $tazpkg\n"
705 }
707 # Verify package quality and consistency.
708 packit_quality() {
709 #gettext "QA: Checking for broken link..."
710 #link=$(find $fs/usr -type l -follow)
711 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
712 #status
714 # Exit if any error found in log file.
715 if fgrep -q ERROR: $LOGS/$pkg.log; then
716 rm -f $command && exit 1
717 fi
719 gettext "QA: Checking for empty package..."
720 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
721 if [ "$files" == 0 ] && [ "$CATEGORY" != "meta" ]; then
722 echo -e "\nERROR: empty package"
723 rm -f $command && exit 1
724 else
725 # Ls sort by name so the first file is the one we want.
726 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
727 status
728 if [ -f "$old" ]; then
729 gettext "Removing old: $(basename $old)"
730 rm -f $old && status
731 fi
732 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
733 sed -i /^${pkg}$/d $broken
734 #gettext "Removing source tree..."
735 #rm -f $WOK/$pkg/source && status
736 fi
737 }
739 #
740 # Commands
741 #
743 case "$1" in
744 usage|help|-u|-h)
745 usage ;;
746 list-wok)
747 gettext -e "\nList of packages in:"; echo " $WOK"
748 separator
749 cd $WOK && ls -1
750 separator
751 echo -n "Packages: " && ls | wc -l
752 echo "" ;;
753 search)
754 # Just a simple search function, we dont need more actually.
755 query="$2"
756 gettext -e "\nSearch results for:"; echo " $query"
757 separator
758 cd $WOK && ls -1 | grep "$query"
759 separator && echo "" ;;
760 setup)
761 # Setup a build environment
762 check_root
763 echo "Cook: setting up the environment" | log
764 gettext -e "\nSetting up your environment\n"
765 separator && cd $SLITAZ
766 init_db_files
767 gettext -e "Checking for packages to install...\n"
768 for pkg in $SETUP_PKGS
769 do
770 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
771 done
773 # Handle --options
774 case "$2" in
775 --wok|-w)
776 hg clone $WOK_URL wok || exit 1 ;;
777 --stable)
778 hg clone $WOK_URL-stable wok || exit 1 ;;
779 --undigest)
780 hg clone $WOK_URL-undigest wok || exit 1 ;;
781 esac
783 # SliTaz group and permissions
784 if ! grep -q ^slitaz /etc/group; then
785 gettext -e "Adding group: slitaz\n"
786 addgroup slitaz
787 fi
788 gettext -e "Setting permissions for slitaz group...\n"
789 chown -R root.slitaz $SLITAZ
790 chmod -R g+w $SLITAZ
791 separator
792 gettext -e "All done, ready to cook packages :-)\n\n" ;;
793 test)
794 # Test a cook environment.
795 echo "Cook test: testing the cook environment" | log
796 [ ! -d "$WOK" ] && exit 1
797 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
798 cook cooktest ;;
799 new)
800 # Create the package folder and an empty receipt.
801 pkg="$2"
802 [ "$pkg" ] || usage
803 echo ""
804 if [ -d "$WOK/$pkg" ]; then
805 echo -n "$pkg " && gettext "package already exists."
806 echo -e "\n" && exit 1
807 fi
808 gettext "Creating"; echo -n " $WOK/$pkg"
809 mkdir $WOK/$pkg && cd $WOK/$pkg && status
810 gettext "Preparing the package receipt..."
811 cp $DATA/receipt .
812 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
813 status && echo ""
815 # Interactive mode, asking and seding.
816 case "$3" in
817 --interactive|-x)
818 gettext -e "Entering interactive mode...\n"
819 separator
820 echo "Package : $pkg"
821 # Version.
822 echo -n "Version : " ; read anser
823 sed -i s/'VERSION=\"\"'/"VERSION=\"$anser\""/ receipt
824 # Category.
825 echo -n "Category : " ; read anser
826 sed -i s/'CATEGORY=\"\"'/"CATEGORY=\"$anser\""/ receipt
827 # Short description.
828 echo -n "Short desc : " ; read anser
829 sed -i s/'SHORT_DESC=\"\"'/"SHORT_DESC=\"$anser\""/ receipt
830 # Maintainer.
831 echo -n "Maintainer : " ; read anser
832 sed -i s/'MAINTAINER=\"\"'/"MAINTAINER=\"$anser\""/ receipt
833 # Web site.
834 echo -n "Web site : " ; read anser
835 sed -i s#'WEB_SITE=\"\"'#"WEB_SITE=\"$anser\""# receipt
836 echo ""
837 # Wget URL.
838 echo "Wget URL to download source tarball."
839 echo "Example : \$GNU_MIRROR/\$PACKAGE/\$TARBALL"
840 echo -n "Wget url : " ; read anser
841 sed -i s#'WGET_URL=\"$TARBALL\"'#"WGET_URL=\"$anser\""# receipt
842 # Ask for a stuff dir.
843 echo -n "Do you need a stuff directory ? (y/N) : " ; read anser
844 if [ "$anser" = "y" ]; then
845 echo -n "Creating the stuff directory..."
846 mkdir $WOK/$pkg/stuff && status
847 fi
848 # Ask for a description file.
849 echo -n "Are you going to write a description ? (y/N) : " ; read anser
850 if [ "$anser" = "y" ]; then
851 echo -n "Creating the description.txt file..."
852 echo "" > $WOK/$pkg/description.txt && status
853 fi
854 separator
855 gettext -e "Receipt is ready to use.\n"
856 echo "" ;;
857 esac ;;
858 list)
859 # Cook a list of packages (better use the Cooker since it will order
860 # packages before executing cook).
861 check_root
862 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
863 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
864 echo -e " $2\n" && exit 1
865 echo "Cook list starting: $2" | log
866 for pkg in $(cat $2)
867 do
868 cook $pkg || broken
869 done ;;
870 clean-wok)
871 check_root
872 gettext -e "\nCleaning all packages files..."
873 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
874 status && echo "" ;;
875 clean-src)
876 check_root
877 gettext -e "\nCleaning all packages sources..."
878 rm -rf $WOK/*/source
879 status && echo "" ;;
880 pkgdb)
881 # Create suitable packages list for TazPKG and only for built packages
882 # as well as flavors files for TazLiTo. We dont need logs since we do it
883 # manually to ensure everything is fine before syncing the mirror.
884 case "$2" in
885 --flavors)
886 continue ;;
887 *)
888 [ "$2" ] && PKGS="$2"
889 [ ! -d "$PKGS" ] && \
890 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1 ;;
891 esac
892 time=$(date +%s)
893 flavors=$SLITAZ/flavors
894 live=$SLITAZ/live
895 echo "cook:pkgdb" > $command
896 echo "Cook pkgdb: Creating all packages lists" | log
897 echo ""
898 gettext "Creating lists for: "; echo "$PKGS"
899 separator
900 gettext "Cook pkgdb started: "; date "+%Y-%m-%d %H:%M"
901 cd $PKGS
902 rm -f packages.*
903 gettext -e "Creating: packages.list\n"
904 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
905 gettext -e "Creating: packages.md5\n"
906 md5sum *.tazpkg > $PKGS/packages.md5
907 gettext -e "Creating lists from: "; echo "$WOK"
908 cd $WOK
909 for pkg in *
910 do
911 unset_receipt
912 . $pkg/receipt
913 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
914 # PACKED_SIZE and UNPACKED_SIZE are only in built receipt
915 . $pkg/taz/*/receipt
916 # packages.desc lets us search easily in DB
917 cat >> $PKGS/packages.desc << EOT
918 $PACKAGE | ${VERSION}$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
919 EOT
920 # packages.txt used by tazpkg and tazpkg-web also to provide
921 # a human readable package list with version and description.
922 cat >> $PKGS/packages.txt << EOT
923 $PACKAGE
924 ${VERSION}$EXTRAVERSION
925 $SHORT_DESC
926 $PACKED_SIZE ($UNPACKED_SIZE installed)
928 EOT
929 # packages.equiv is used by tazpkg install to check depends.
930 for i in $PROVIDE; do
931 DEST=""
932 echo $i | fgrep -q : && DEST="${i#*:}:"
933 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
934 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
935 $PKGS/packages.equiv
936 else
937 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
938 fi
939 done
940 # files.list provides a list of all packages files.
941 cat $pkg/taz/*/files.list | sed s/^/"$pkg: \0"/ >> \
942 $PKGS/files.list
943 fi
944 done
946 # Display list size.
947 gettext -e "Done: packages.desc\n"
948 gettext -e "Done: packages.txt\n"
949 gettext -e "Done: packages.equiv\n"
951 # files.list.lzma
952 gettext -e "Creating: files.list.lzma\n"
953 cd $PKGS && lzma e files.list files.list.lzma
954 rm -f files.list
956 # Display some info.
957 separator
958 nb=$(ls $PKGS/*.tazpkg | wc -l)
959 time=$(($(date +%s) - $time))
960 echo -e "Packages: $nb - Time: ${time}s\n"
962 # Create all flavors files at once. Do we really need code to monitor
963 # flavors changes ? Lets just build them with packages lists before
964 # syncing the mirror.
965 [ "$2" == "--flavors" ] || exit 1
966 [ ! -d "$flavors" ] && echo -e "Missing flavors: $flavors\n" && exit 1
967 [ -d "$live" ] || mkdir -p $live
968 gettext "Creating flavors files in:"; echo " $live"
969 echo "Cook pkgdb: Creating all flavors" | log
970 separator
971 gettext -e "Recharging lists to use latest packages...\n"
972 tazpkg recharge 2>1 >/dev/null
974 # We need a custom tazlito config to set working dir to /home/slitaz.
975 if [ ! -f "$live/tazlito.conf" ]; then
976 echo "Creating configuration file: tazlito.conf"
977 cp /etc/tazlito/tazlito.conf $live
978 sed -i s@WORK_DIR=.*@WORK_DIR=\"/home/slitaz\"@ \
979 $live/tazlito.conf
980 fi
982 # Update Hg flavors repo and pack.
983 [ -d "$flavors/.hg" ] && cd $flavors && hg pull -u
985 cd $live
986 echo "Starting to generate flavors..."
987 rm -f flavors.list *.flavor
988 for i in $flavors/*
989 do
990 fl=$(basename $i)
991 echo "Packing flavor: $(basename $i)"
992 tazlito pack-flavor $fl >/dev/null || exit 1
993 tazlito show-flavor $fl --brief --noheader 2> \
994 /dev/null >> flavors.list
995 done
996 cp -f $live/*.flavor $live/flavors.list $PKGS
997 separator && gettext "Flavors size: "; du -sh $live | awk '{print $1}'
998 echo "" && rm -f $command ;;
999 *)
1000 # Just cook and generate a package.
1001 check_root
1002 time=$(date +%s)
1003 pkg="$1"
1004 [ -z "$pkg" ] && usage
1005 receipt="$WOK/$pkg/receipt"
1006 check_pkg_in_wok && echo ""
1008 # Display and log info if cook process stopped.
1009 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
1010 tee -a $LOGS/$pkg.log' INT
1012 # Skip blocked, 3 lines also for the Cooker.
1013 if grep -q "^$pkg$" $blocked && [ "$2" != "--unblock" ]; then
1014 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
1015 fi
1017 # Log and source receipt.
1018 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
1019 echo "cook:$pkg" > $command
1020 unset inst
1021 unset_receipt
1022 . $receipt
1024 # Handle --options
1025 case "$2" in
1026 --clean|-c)
1027 gettext -e "Cleaning:"; echo -n " $pkg"
1028 cd $WOK/$pkg && rm -rf install taz source
1029 status && echo "" && exit 0 ;;
1030 --install|-i)
1031 inst='yes' ;;
1032 --getsrc|-gs)
1033 gettext "Getting source for:"; echo " $pkg"
1034 separator && get_source
1035 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
1036 --block|-b)
1037 gettext "Blocking:"; echo -n " $pkg"
1038 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
1039 status && echo "" && exit 0 ;;
1040 --unblock|-ub)
1041 gettext "Unblocking:"; echo -n " $pkg"
1042 sed -i "/^${pkg}$/"d $blocked
1043 status && echo "" && exit 0 ;;
1045 esac
1047 # Check if wanted is built now so we have separate log files.
1048 if [ "$WANTED" ]; then
1049 if grep -q "^$WANTED$" $blocked; then
1050 echo "WANTED package is blocked: $WANTED" | tee $LOGS/$pkg.log
1051 echo "" && rm -f $command && exit 1
1052 fi
1053 if grep -q "^$WANTED$" $broken; then
1054 echo "WANTED package is broken: $WANTED" | tee $LOGS/$pkg.log
1055 echo "" && rm -f $command && exit 1
1056 fi
1057 if [ ! -d "$WOK/$WANTED/install" ]; then
1058 cook "$WANTED" || exit 1
1059 fi
1060 fi
1062 # Cook and pack or exit on error and log everything.
1063 cookit $@ 2>&1 | tee $LOGS/$pkg.log
1064 remove_deps | tee -a $LOGS/$pkg.log
1065 cookit_quality
1066 packit 2>&1 | tee -a $LOGS/$pkg.log
1067 clean_log
1069 # Exit if any error in packing.
1070 if grep -q ^ERROR $LOGS/$pkg.log; then
1071 debug_info | tee -a $LOGS/$pkg.log
1072 rm -f $command && exit 1
1073 fi
1075 # Time and summary
1076 time=$(($(date +%s) - $time))
1077 summary | tee -a $LOGS/$pkg.log
1078 echo ""
1080 # Install package if requested
1081 if [ "$inst" ]; then
1082 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
1083 cd $PKGS && tazpkg install \
1084 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
1085 else
1086 gettext -e "Unable to install package, build has failed.\n\n"
1087 exit 1
1088 fi
1089 fi
1090 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
1091 # You want automation: use the Cooker Build Bot.
1092 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
1093 rm -f $command ;;
1094 esac
1096 exit 0